#ifndef APPS_H_INCLUDED
#define APPS_H_INCLUDED

#include "./clocktimer.h"
#include "../types/ranged.h"
#include "../types/mytypes.h"
#include "../driver/keys.h"
#include "../menu/displayroutines.h"

//Pin Definitionen
#define RXD PD0
#define TXD PD1
#define Vacuum PD2
#define Lampen1 PD3
#define Lampen2 PD4
#define Buzzer PD5
#define BackLight PD6
#define Selbsthaltung PD7


//Events ->
//#define LEFT 1  //S3
//#define DOWN 2  //S2
//#define OK 3  //S5
//#define UP 4  //S1
//#define RIGHT 5  //S4
#define ONE_MINUTE_TICK 0xFD
#define TICK 0xFE//
#define NO_KEY 0xFF //



void Beep();
char* SwitchpointToASCII(const t_Switchpoint *aSwitchpoint);

void DisplayTimeAt(uint8_t x,uint8_t y, t_datetime *time);
void DisplayDateAt(uint8_t x,uint8_t y, t_datetime *date, uint8_t withdayname);
char* _2DigitValueWithLeadingNull(uint8_t *value);
void Print2DigitValueWithLeadingNull(uint8_t *value, char *buffer);
//*********************************************************
typedef void (*t_ActiveApplication) (uint8_t);
t_ActiveApplication ActiveApplication;

//MenuApp ->
void MenuApplication(uint8_t Button);
//*********************************************************

// BackLightApplication->
void setBackLightPWMValue( uint8_t *pBackLightPWM);
void BackLightApplication(uint8_t Button);
//*********************************************************

//SetTimeApp ->
void SetDateTimeToChange(const t_datetime datetime);
void SetTimeApp(uint8_t Event);
//*********************************************************

//EditSwitchpointApplication ->
void EditSwitchpointApp(uint8_t Event);
//*********************************************************

//IdleApplication->
void IdleApplication(uint8_t Event);
//*********************************************************

// Select Operating Mode Application
void SelectOperatingModeApp(uint8_t Event);
//*********************************************************
#endif // APPS_H_INCLUDED
